/**
 * 封装COS, 对接腾讯COS对象存储
 * 文档路径： https://cloud.tencent.com/document/product/436/11459
 */
// import axios from 'axios'
import {getS3Config2, getResourceS3Config} from '../apis/common'
// import {serverUrl} from '../config'


// const config = {
//   useCdnDomain: true
//   // region: qiniu.region.z2
// }

// 导出 封装上传对象 提取关键操作
export default new (class {
  constructor () {
  }

  /**
   * 单文件上传
   * @param file
   * @param optioins
   * @returns {Promise<unknown>}
   */
  async putObject (file, options) {
    return new Promise(async (resolve, reject) => {
      const FileName = this._generateFileName(file.name || '')
      const res = await getS3Config2({
        file_name: FileName
      })
      const formData = new FormData()
      // console.log(res, 'res')
      Object.keys(res.data.fields).forEach((key) => {
        formData.append(key, res.data.fields[key])
      })
      formData.append('file', file)
      const _targetUrl = res.data.url
      fetch(_targetUrl, {
        method: 'post',
        headers: {
          // 'Content-Type': 'multipart/form-data'
        },
        // body: {...res.data.fields, file}
        body: formData
      }).then((rest) => {
        if (rest.status == 200 || rest.status == 204) {
          // console.log(rest)
          resolve(res)
          return Promise.resolve(res)
        } else {
          reject(error)
          return Promise.reject(error)
        }
      }).catch(err => {
        console.log(err)
        reject(res)
        return Promise.reject(res)
      })
      // axios.post(_targetUrl, {...res.data.fields, file}, {
      //   headers: {
      //     // ...res.data.fields,
      //     // 'X-Amz-Acl': res.data.fields.acl,
      //     'Content-Type': 'multipart/form-data'
      //   }
      // }).then((rest) => {
      //   if (rest.status == 200 || rest.status == 204) {
      //     resolve(res)
      //     return Promise.resolve(res)
      //   } else {
      //     reject(error)
      //     return Promise.reject(error)
      //   }
      // }).catch(err => {
      //   // console.log(err)
      //   reject(res)
      //   return Promise.reject(res)
      // })
    })
  }

  // 内容生成
  async putSourceObject (file, options) {
    return new Promise(async (resolve, reject) => {
      const FileName = this._generateFileName(file.name || '')
      const res = await getResourceS3Config({
        file_name: FileName
      })
      const formData = new FormData()
      Object.keys(res.data.fields).forEach((key) => {
        formData.append(key, res.data.fields[key])
      })
      formData.append('file', file)
      const _targetUrl = res.data.url
      fetch(_targetUrl, {
        method: 'post',
        headers: {
          // 'Content-Type': 'multipart/form-data'
        },
        // body: {...res.data.fields, file}
        body: formData
      }).then((rest) => {
        if (rest.status == 200 || rest.status == 204) {
          // console.log(rest)
          resolve(res)
          return Promise.resolve(res)
        } else {
          reject(error)
          return Promise.reject(error)
        }
      }).catch(err => {
        console.log(err)
        reject(res)
        return Promise.reject(res)
      })
    })
  }

  // 文件名加工、确保唯一性
  _generateFileName (file_name) {
    try {
      const len = file_name.split('.').length
      file_name = `${this._randomSign(6)}.${file_name.split('.')[len - 1]}`
    } catch (e) {
      file_name = 'ren' + Date.now()
    }
    return file_name
  }

  // 生成随机签名
  _randomSign (len) {
    return `${this._randomString(len)}_${parseInt(Math.floor(Math.random() * Date.now()) / 1000)}`
  }

  // 生成随机串
  _randomString (len) {
    len = len || 6
    let chars = 'ABCDEFGHJKMNPQRSTWXYZabcdefhijkmnprstwxyz'
    let maxPos = chars.length
    let pwd = ''
    for (let i = 0; i < len; i++) {
      pwd += chars.charAt(Math.floor(Math.random() * maxPos))
    }
    return pwd
  }
})()
